<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAddSensorDeviceInput ArrayType
 * @subpackage Arrays
 */
class ArrayOfAddSensorDeviceInput extends AbstractStructArrayBase
{
    /**
     * The AddSensorDeviceInput
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\AddSensorDeviceInput[]
     */
    public $AddSensorDeviceInput;
    /**
     * Constructor method for ArrayOfAddSensorDeviceInput
     * @uses ArrayOfAddSensorDeviceInput::setAddSensorDeviceInput()
     * @param \CustomerManagement\StructType\AddSensorDeviceInput[] $addSensorDeviceInput
     */
    public function __construct(array $addSensorDeviceInput = array())
    {
        $this
            ->setAddSensorDeviceInput($addSensorDeviceInput);
    }
    /**
     * Get AddSensorDeviceInput value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\AddSensorDeviceInput[]|null
     */
    public function getAddSensorDeviceInput()
    {
        return isset($this->AddSensorDeviceInput) ? $this->AddSensorDeviceInput : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAddSensorDeviceInput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddSensorDeviceInput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAddSensorDeviceInputForArrayConstraintsFromSetAddSensorDeviceInput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAddSensorDeviceInputAddSensorDeviceInputItem) {
            // validation for constraint: itemType
            if (!$arrayOfAddSensorDeviceInputAddSensorDeviceInputItem instanceof \CustomerManagement\StructType\AddSensorDeviceInput) {
                $invalidValues[] = is_object($arrayOfAddSensorDeviceInputAddSensorDeviceInputItem) ? get_class($arrayOfAddSensorDeviceInputAddSensorDeviceInputItem) : sprintf('%s(%s)', gettype($arrayOfAddSensorDeviceInputAddSensorDeviceInputItem), var_export($arrayOfAddSensorDeviceInputAddSensorDeviceInputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AddSensorDeviceInput property can only contain items of type \CustomerManagement\StructType\AddSensorDeviceInput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AddSensorDeviceInput value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\AddSensorDeviceInput[] $addSensorDeviceInput
     * @return \CustomerManagement\ArrayType\ArrayOfAddSensorDeviceInput
     */
    public function setAddSensorDeviceInput(array $addSensorDeviceInput = array())
    {
        // validation for constraint: array
        if ('' !== ($addSensorDeviceInputArrayErrorMessage = self::validateAddSensorDeviceInputForArrayConstraintsFromSetAddSensorDeviceInput($addSensorDeviceInput))) {
            throw new \InvalidArgumentException($addSensorDeviceInputArrayErrorMessage, __LINE__);
        }
        if (is_null($addSensorDeviceInput) || (is_array($addSensorDeviceInput) && empty($addSensorDeviceInput))) {
            unset($this->AddSensorDeviceInput);
        } else {
            $this->AddSensorDeviceInput = $addSensorDeviceInput;
        }
        return $this;
    }
    /**
     * Add item to AddSensorDeviceInput value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\AddSensorDeviceInput $item
     * @return \CustomerManagement\ArrayType\ArrayOfAddSensorDeviceInput
     */
    public function addToAddSensorDeviceInput(\CustomerManagement\StructType\AddSensorDeviceInput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\AddSensorDeviceInput) {
            throw new \InvalidArgumentException(sprintf('The AddSensorDeviceInput property can only contain items of type \CustomerManagement\StructType\AddSensorDeviceInput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AddSensorDeviceInput[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\AddSensorDeviceInput|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\AddSensorDeviceInput|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\AddSensorDeviceInput|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\AddSensorDeviceInput|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\AddSensorDeviceInput|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AddSensorDeviceInput
     */
    public function getAttributeName()
    {
        return 'AddSensorDeviceInput';
    }
}
